"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
import httpx
from orq_ai_sdk.models import OrqError
from orq_ai_sdk.types import BaseModel, Nullable, UNSET_SENTINEL
from pydantic import model_serializer
from typing import List, Optional, Union
from typing_extensions import TypeAliasType, TypedDict


class EvalsContainsAnyFunctionParamsTypedDict(TypedDict):
    keywords: List[str]


class EvalsContainsAnyFunctionParams(BaseModel):
    keywords: List[str]


class EvalsContainsAnyRequestBodyTypedDict(TypedDict):
    output: str
    function_params: EvalsContainsAnyFunctionParamsTypedDict


class EvalsContainsAnyRequestBody(BaseModel):
    output: str

    function_params: EvalsContainsAnyFunctionParams


class EvalsContainsAnyEvalsResponseResponseBodyData(BaseModel):
    message: str


class EvalsContainsAnyEvalsResponseResponseBody(OrqError):
    r"""Internal server error"""

    data: EvalsContainsAnyEvalsResponseResponseBodyData

    def __init__(
        self,
        data: EvalsContainsAnyEvalsResponseResponseBodyData,
        raw_response: httpx.Response,
        body: Optional[str] = None,
    ):
        fallback = body or raw_response.text
        message = str(data.message) or fallback
        super().__init__(message, raw_response, body)
        self.data = data


class EvalsContainsAnyEvalsResponseBodyData(BaseModel):
    message: str


class EvalsContainsAnyEvalsResponseBody(OrqError):
    r"""Evaluator not found"""

    data: EvalsContainsAnyEvalsResponseBodyData

    def __init__(
        self,
        data: EvalsContainsAnyEvalsResponseBodyData,
        raw_response: httpx.Response,
        body: Optional[str] = None,
    ):
        fallback = body or raw_response.text
        message = str(data.message) or fallback
        super().__init__(message, raw_response, body)
        self.data = data


EvalsContainsAnyValueTypedDict = TypeAliasType(
    "EvalsContainsAnyValueTypedDict", Union[bool, str, float]
)


EvalsContainsAnyValue = TypeAliasType("EvalsContainsAnyValue", Union[bool, str, float])


class EvalsContainsAnyResponseBodyTypedDict(TypedDict):
    r"""Returns the result of the evaluator run"""

    value: Nullable[EvalsContainsAnyValueTypedDict]


class EvalsContainsAnyResponseBody(BaseModel):
    r"""Returns the result of the evaluator run"""

    value: Nullable[EvalsContainsAnyValue]

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = []
        nullable_fields = ["value"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in type(self).model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m
