"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
import httpx
from orq_ai_sdk.models import OrqError
from orq_ai_sdk.types import BaseModel, Nullable, UNSET_SENTINEL
from pydantic import model_serializer
from typing import Optional
from typing_extensions import NotRequired, TypedDict


class EvalsRagasCorrectnessRequestBodyTypedDict(TypedDict):
    query: str
    r"""Latest user message"""
    output: str
    r"""The generated response from the model"""
    model: str
    reference: NotRequired[str]
    r"""The reference used to compare the output"""


class EvalsRagasCorrectnessRequestBody(BaseModel):
    query: str
    r"""Latest user message"""

    output: str
    r"""The generated response from the model"""

    model: str

    reference: Optional[str] = None
    r"""The reference used to compare the output"""


class EvalsRagasCorrectnessEvalsResponseResponseBodyData(BaseModel):
    message: str


class EvalsRagasCorrectnessEvalsResponseResponseBody(OrqError):
    r"""Internal server error"""

    data: EvalsRagasCorrectnessEvalsResponseResponseBodyData

    def __init__(
        self,
        data: EvalsRagasCorrectnessEvalsResponseResponseBodyData,
        raw_response: httpx.Response,
        body: Optional[str] = None,
    ):
        fallback = body or raw_response.text
        message = str(data.message) or fallback
        super().__init__(message, raw_response, body)
        self.data = data


class EvalsRagasCorrectnessEvalsResponseBodyData(BaseModel):
    message: str


class EvalsRagasCorrectnessEvalsResponseBody(OrqError):
    r"""Evaluator not found"""

    data: EvalsRagasCorrectnessEvalsResponseBodyData

    def __init__(
        self,
        data: EvalsRagasCorrectnessEvalsResponseBodyData,
        raw_response: httpx.Response,
        body: Optional[str] = None,
    ):
        fallback = body or raw_response.text
        message = str(data.message) or fallback
        super().__init__(message, raw_response, body)
        self.data = data


class EvalsRagasCorrectnessResponseBodyTypedDict(TypedDict):
    r"""Returns the correctness evaluation result"""

    value: Nullable[float]


class EvalsRagasCorrectnessResponseBody(BaseModel):
    r"""Returns the correctness evaluation result"""

    value: Nullable[float]

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = []
        nullable_fields = ["value"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in type(self).model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m
